

```julia
using StatisticalRethinking
gr(size=(300,300))

Turing.setadbackend(:reverse_diff)

ProjDir = @__DIR__
cd(ProjDir)
```

    loaded


    ┌ Warning: Package Turing does not have CmdStan in its dependencies:
    │ - If you have Turing checked out for development and have
    │   added CmdStan as a dependency but haven't updated your primary
    │   environment's manifest file, try `Pkg.resolve()`.
    │ - Otherwise you may need to report an issue with Turing
    │ Loading CmdStan into Turing from project dependency, future warnings for Turing are suppressed.
    └ @ nothing nothing:840
    WARNING: using CmdStan.Sample in module Turing conflicts with an existing identifier.


### snippet 4.38


```julia
howell1 = CSV.read(joinpath(dirname(Base.pathof(StatisticalRethinking)), "..", "data", "Howell1.csv"), delim=';')
df = convert(DataFrame, howell1);
```

Use only adults


```julia
df2 = filter(row -> row[:age] >= 18, df);
y = df2[:height];
x = df2[:weight];
```

Define the regression model


```julia
@model line(y, x) = begin
    #priors
    alpha ~ Normal(178.0, 100.0)
    beta ~ Normal(0.0, 10.0)
    s ~ Uniform(0, 50)

    #model
    mu = alpha .+ beta*x
    for i in 1:length(y)
      y[i] ~ Normal(mu[i], s)
    end
end;
```

Draw the samples


```julia
chn = sample(line(y, x), Turing.NUTS(1000, 0.65));
```

    ┌ Info: [Turing] looking for good initial eps...
    └ @ Turing /Users/rob/.julia/packages/Turing/orJH9/src/samplers/support/hmc_core.jl:246
    [NUTS{Any}] found initial ϵ: 0.05
    └ @ Turing /Users/rob/.julia/packages/Turing/orJH9/src/samplers/support/hmc_core.jl:291
    [32m[NUTS] Sampling...  0%  ETA: 2:23:28[39m
    [34m  ϵ:         0.05[39m
    [34m  α:         0.5958469110979258[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  1%  ETA: 0:16:09[39m
    [34m  ϵ:         0.025127276843784265[39m
    [34m  α:         0.8255173439569742[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  2%  ETA: 0:08:07[39m
    [34m  ϵ:         0.00851550348406546[39m
    [34m  α:         0.9973471187140496[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  3%  ETA: 0:07:31[39m
    [34m  ϵ:         0.007488854283617242[39m
    [34m  α:         0.9966676932439508[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  3%  ETA: 0:07:10[39m
    [34m  ϵ:         0.023359709956663345[39m
    [34m  α:         0.8317960966270578[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  4%  ETA: 0:05:45[39m
    [34m  ϵ:         0.016127966083582905[39m
    [34m  α:         0.9751874958408335[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  5%  ETA: 0:05:42[39m
    [34m  ϵ:         0.008813589454963862[39m
    [34m  α:         0.9971288119295713[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  5%  ETA: 0:05:34[39m
    [34m  ϵ:         0.03248192025884401[39m
    [34m  α:         0.5864150451907146[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  6%  ETA: 0:05:04[39m
    [34m  ϵ:         0.00901519552162794[39m
    [34m  α:         0.9986803229850687[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  6%  ETA: 0:05:07[39m
    [34m  ϵ:         0.014747236072985486[39m
    [34m  α:         0.9800664253311455[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  7%  ETA: 0:05:06[39m
    [34m  ϵ:         0.00965336217165113[39m
    [34m  α:         0.9999581189235383[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  8%  ETA: 0:04:46[39m
    [34m  ϵ:         0.010015851061809845[39m
    [34m  α:         0.9999594826344835[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  8%  ETA: 0:04:32[39m
    [34m  ϵ:         0.01578501722592339[39m
    [34m  α:         1.0[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling...  9%  ETA: 0:04:19[39m
    [34m  ϵ:         0.015513521070662171[39m
    [34m  α:         0.8919170400899573[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 10%  ETA: 0:04:17[39m
    [34m  ϵ:         0.014195283529381653[39m
    [34m  α:         0.9571669004122665[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 10%  ETA: 0:04:24[39m
    [34m  ϵ:         0.025364058061337482[39m
    [34m  α:         0.6381469302922957[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 10%  ETA: 0:04:14[39m
    [34m  ϵ:         0.005982454027802865[39m
    [34m  α:         0.9979231791309169[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 11%  ETA: 0:04:16[39m
    [34m  ϵ:         0.00718218178908927[39m
    [34m  α:         0.9961240637045707[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 11%  ETA: 0:04:13[39m
    [34m  ϵ:         0.006107587796129112[39m
    [34m  α:         0.9984288567948547[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 12%  ETA: 0:04:12[39m
    [34m  ϵ:         0.022109631240016605[39m
    [34m  α:         0.925978903393585[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 12%  ETA: 0:04:05[39m
    [34m  ϵ:         0.02388426012906928[39m
    [34m  α:         0.9581414677634983[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 13%  ETA: 0:04:04[39m
    [34m  ϵ:         0.00944682419634701[39m
    [34m  α:         0.9915755233512149[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 13%  ETA: 0:04:06[39m
    [34m  ϵ:         0.00837661029851762[39m
    [34m  α:         0.9924702125479083[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 14%  ETA: 0:03:54[39m
    [34m  ϵ:         0.01237312839968317[39m
    [34m  α:         0.9997010022111945[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 15%  ETA: 0:03:45[39m
    [34m  ϵ:         0.044838771724791754[39m
    [34m  α:         0.0007231584721505598[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 16%  ETA: 0:03:41[39m
    [34m  ϵ:         0.012431219772575601[39m
    [34m  α:         0.9952663597442306[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 16%  ETA: 0:03:40[39m
    [34m  ϵ:         0.005447763563671964[39m
    [34m  α:         0.9994970086239011[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 16%  ETA: 0:03:40[39m
    [34m  ϵ:         0.008870583180892622[39m
    [34m  α:         0.9919721043756654[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 17%  ETA: 0:03:38[39m
    [34m  ϵ:         0.011775209144808263[39m
    [34m  α:         0.9744507378011469[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 18%  ETA: 0:03:36[39m
    [34m  ϵ:         0.005711891175352187[39m
    [34m  α:         0.9997494461488865[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 18%  ETA: 0:03:34[39m
    [34m  ϵ:         0.0423801744416322[39m
    [34m  α:         0.3092761809051894[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 19%  ETA: 0:03:22[39m
    [34m  ϵ:         0.02060721236115353[39m
    [34m  α:         0.9964768235583681[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 20%  ETA: 0:03:16[39m
    [34m  ϵ:         0.010156350403491325[39m
    [34m  α:         0.9754111069770062[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 21%  ETA: 0:03:06[39m
    [34m  ϵ:         0.027614545232751843[39m
    [34m  α:         0.8246540434075277[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 22%  ETA: 0:03:06[39m
    [34m  ϵ:         0.017259084247298623[39m
    [34m  α:         0.9131699260862771[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 22%  ETA: 0:03:05[39m
    [34m  ϵ:         0.013431284897113937[39m
    [34m  α:         0.9925283447313975[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 23%  ETA: 0:03:05[39m
    [34m  ϵ:         0.011832113733028594[39m
    [34m  α:         0.999057355500345[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 24%  ETA: 0:03:04[39m
    [34m  ϵ:         0.026442553991805062[39m
    [34m  α:         0.2999838223674451[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 24%  ETA: 0:03:05[39m
    [34m  ϵ:         0.012420069797388657[39m
    [34m  α:         0.9988159535773793[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 24%  ETA: 0:03:02[39m
    [34m  ϵ:         0.011121126232923783[39m
    [34m  α:         0.9980320890961634[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 25%  ETA: 0:02:57[39m
    [34m  ϵ:         0.007438132895977654[39m
    [34m  α:         0.9859047364680493[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 26%  ETA: 0:02:56[39m
    [34m  ϵ:         0.003711814549519056[39m
    [34m  α:         0.9963716573087572[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 27%  ETA: 0:02:50[39m
    [34m  ϵ:         0.0064845521097339235[39m
    [34m  α:         0.9959111036797161[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 28%  ETA: 0:02:41[39m
    [34m  ϵ:         0.006280622649199679[39m
    [34m  α:         0.995970956132406[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 29%  ETA: 0:02:43[39m
    [34m  ϵ:         0.0055866317162223764[39m
    [34m  α:         0.9862155395387813[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 30%  ETA: 0:02:38[39m
    [34m  ϵ:         0.007989524811837085[39m
    [34m  α:         0.9980620201108341[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 30%  ETA: 0:02:36[39m
    [34m  ϵ:         0.02288244260922675[39m
    [34m  α:         0.9709808183913866[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 31%  ETA: 0:02:33[39m
    [34m  ϵ:         0.049833761001675886[39m
    [34m  α:         0.00021626650148486005[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 32%  ETA: 0:02:32[39m
    [34m  ϵ:         0.008130603376851358[39m
    [34m  α:         0.9999866856263872[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 33%  ETA: 0:02:28[39m
    [34m  ϵ:         0.011526240381501615[39m
    [34m  α:         0.9762554272657571[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 33%  ETA: 0:02:27[39m
    [34m  ϵ:         0.014809127007086708[39m
    [34m  α:         0.9961294496213143[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 34%  ETA: 0:02:29[39m
    [34m  ϵ:         0.02430631072586857[39m
    [34m  α:         0.88222840441524[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 34%  ETA: 0:02:25[39m
    [34m  ϵ:         0.018503950588776907[39m
    [34m  α:         0.5285285429091524[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 35%  ETA: 0:02:21[39m
    [34m  ϵ:         0.01168814609138677[39m
    [34m  α:         0.999012469594811[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 36%  ETA: 0:02:19[39m
    [34m  ϵ:         0.0083580419493583[39m
    [34m  α:         0.9999448725220954[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 36%  ETA: 0:02:19[39m
    [34m  ϵ:         0.02296627218528175[39m
    [34m  α:         0.8944536670612164[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 37%  ETA: 0:02:18[39m
    [34m  ϵ:         0.012706497376307585[39m
    [34m  α:         0.9997151695133639[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 37%  ETA: 0:02:18[39m
    [34m  ϵ:         0.009736744091032557[39m
    [34m  α:         0.9656672953525859[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 38%  ETA: 0:02:14[39m
    [34m  ϵ:         0.017033446395948625[39m
    [34m  α:         0.9770735216512014[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 39%  ETA: 0:02:14[39m
    [34m  ϵ:         0.017666697060456694[39m
    [34m  α:         0.866679299855932[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 39%  ETA: 0:02:14[39m
    [34m  ϵ:         0.00858769698153709[39m
    [34m  α:         0.9994702592427223[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 40%  ETA: 0:02:12[39m
    [34m  ϵ:         0.014057363097769292[39m
    [34m  α:         0.8490202220469975[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 40%  ETA: 0:02:11[39m
    [34m  ϵ:         0.02145759541761293[39m
    [34m  α:         0.8199068739473638[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 41%  ETA: 0:02:10[39m
    [34m  ϵ:         0.018608749628827092[39m
    [34m  α:         0.8809014950504805[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 42%  ETA: 0:02:08[39m
    [34m  ϵ:         0.021735064118511976[39m
    [34m  α:         0.9691183537837947[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 42%  ETA: 0:02:06[39m
    [34m  ϵ:         0.009740403144477425[39m
    [34m  α:         0.9965050055471739[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 43%  ETA: 0:02:06[39m
    [34m  ϵ:         0.00958401510251089[39m
    [34m  α:         0.9992534320583438[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 43%  ETA: 0:02:03[39m
    [34m  ϵ:         0.020289144083874375[39m
    [34m  α:         0.9974608969276128[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 45%  ETA: 0:01:57[39m
    [34m  ϵ:         0.016929543920738904[39m
    [34m  α:         0.996790222381062[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 46%  ETA: 0:01:55[39m
    [34m  ϵ:         0.011369066950758733[39m
    [34m  α:         0.9175607380726664[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 46%  ETA: 0:01:55[39m
    [34m  ϵ:         0.013748553979606972[39m
    [34m  α:         0.9922036049745192[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 46%  ETA: 0:01:55[39m
    [34m  ϵ:         0.01505310103160407[39m
    [34m  α:         0.9460578992302959[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 47%  ETA: 0:01:54[39m
    [34m  ϵ:         0.016537030255606662[39m
    [34m  α:         0.307105133962934[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 47%  ETA: 0:01:54[39m
    [34m  ϵ:         0.007284604307140954[39m
    [34m  α:         0.9999221534585019[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 48%  ETA: 0:01:54[39m
    [34m  ϵ:         0.009895001230105213[39m
    [34m  α:         0.9903640209158069[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 48%  ETA: 0:01:52[39m
    [34m  ϵ:         0.012928841627830139[39m
    [34m  α:         0.6619275397588733[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 49%  ETA: 0:01:52[39m
    [34m  ϵ:         0.014912282984068234[39m
    [34m  α:         0.8851879627352994[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 49%  ETA: 0:01:50[39m
    [34m  ϵ:         0.01710482163093238[39m
    [34m  α:         0.8219743102766803[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 50%  ETA: 0:01:48[39m
    [34m  ϵ:         0.006799765104485656[39m
    [34m  α:         0.9847463768263129[39m
    [A┌ Info:  Adapted ϵ = 0.013109170393989088, std = [1.0, 1.0, 1.0]; 500 iterations is used for adaption.
    └ @ Turing /Users/rob/.julia/packages/Turing/orJH9/src/samplers/adapt/adapt.jl:91
    
    
    
    [32m[NUTS] Sampling... 51%  ETA: 0:01:47[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9971886146479594[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 51%  ETA: 0:01:45[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9923066813797669[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 52%  ETA: 0:01:44[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9537974050410385[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 52%  ETA: 0:01:45[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9202979426650503[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 52%  ETA: 0:01:45[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9933155202568289[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 53%  ETA: 0:01:44[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9082470677250689[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 54%  ETA: 0:01:42[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.8106847283415165[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 54%  ETA: 0:01:41[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         1.0[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 54%  ETA: 0:01:41[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9734589794803037[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 55%  ETA: 0:01:41[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9293202549111236[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 55%  ETA: 0:01:40[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9468061307971631[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 56%  ETA: 0:01:39[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9984215957795564[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 56%  ETA: 0:01:39[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9835660643994784[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 56%  ETA: 0:01:37[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.8845233539409265[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 57%  ETA: 0:01:37[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.6206797809048188[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 57%  ETA: 0:01:36[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.8254335190404162[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 58%  ETA: 0:01:36[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.932208669035429[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 58%  ETA: 0:01:36[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9647060129142845[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 58%  ETA: 0:01:35[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.8742164313252938[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 59%  ETA: 0:01:34[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         1.0[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 59%  ETA: 0:01:33[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.8584051008323377[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 60%  ETA: 0:01:30[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.6772709261039982[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 61%  ETA: 0:01:28[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.8983637146409795[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 61%  ETA: 0:01:28[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.39019448423443465[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 62%  ETA: 0:01:28[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9891341812654892[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 62%  ETA: 0:01:27[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9720512803349747[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 63%  ETA: 0:01:25[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.3813413804788552[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 63%  ETA: 0:01:24[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9312047627168744[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 64%  ETA: 0:01:22[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.7422415353174983[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 65%  ETA: 0:01:20[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.7869903504720592[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 66%  ETA: 0:01:18[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9505649307490288[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 66%  ETA: 0:01:18[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.7979356852575008[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 67%  ETA: 0:01:17[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9905368623409823[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 68%  ETA: 0:01:12[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.951665549842708[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 69%  ETA: 0:01:11[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.022127310556418162[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 70%  ETA: 0:01:08[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.9104921285142276[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 71%  ETA: 0:01:06[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.29719887767172304[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 72%  ETA: 0:01:03[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         8.336410328488203e-5[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 72%  ETA: 0:01:01[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.0006277866637373233[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 73%  ETA: 0:00:59[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.44471857574623347[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 74%  ETA: 0:00:56[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.8380728543289289[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 75%  ETA: 0:00:54[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.0002628834688017792[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 77%  ETA: 0:00:50[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.3896701756259306[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 77%  ETA: 0:00:49[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.6356450444122348[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 78%  ETA: 0:00:47[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.2328391210737752[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 79%  ETA: 0:00:45[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.6283551382163406[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 79%  ETA: 0:00:44[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.11196407716772744[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 80%  ETA: 0:00:42[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.470555856021405[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 81%  ETA: 0:00:41[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.5637925631104987[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 82%  ETA: 0:00:39[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.052202591288156776[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 82%  ETA: 0:00:38[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.00874300330640224[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 83%  ETA: 0:00:35[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.12971398792108216[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 84%  ETA: 0:00:32[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         2.2904692378334666e-27[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 86%  ETA: 0:00:29[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         1.3835388541105442e-6[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 88%  ETA: 0:00:25[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         9.53094295080429e-21[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 89%  ETA: 0:00:22[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.13767285927717623[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 91%  ETA: 0:00:19[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.20630790916330802[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 93%  ETA: 0:00:13[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         1.0[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 95%  ETA: 0:00:10[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.6333069293764164[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 96%  ETA: 0:00:08[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.4732912353973532[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 98%  ETA: 0:00:05[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.35141304863388073[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    
    [32m[NUTS] Sampling... 99%  ETA: 0:00:02[39m
    [34m  ϵ:         0.013109170393989088[39m
    [34m  α:         0.0015076497721120024[39m
    [A4m  pre_cond:  [1.0, 1.0, 1.0][39m
    
    


    [NUTS] Finished with
      Running time        = 185.92909549900017;
      #lf / sample        = 0.003;
      #evals / sample     = 41.753;
      pre-cond. metric    = [1.0, 1.0, 1.0].


    [32m[NUTS] Sampling...100% Time: 0:03:06[39m


Describe the chain result


```julia
println() # src
describe(chn)
println() # src
```

    
    Iterations = 1:1000
    Thinning interval = 1
    Chains = 1
    Samples per chain = 1000
    
    Empirical Posterior Estimates:
                   Mean           SD         Naive SE       MCSE         ESS    
       alpha    60.409980530  33.97261591 1.07430844345 11.259303401    9.104056
        beta     2.068656449   0.73733869 0.02331669656  0.244276471    9.111099
      lf_num     0.003000000   0.09486833 0.00300000000  0.003000000 1000.000000
           s     9.862403542   5.09915312 0.16124937984  1.492241116   11.676646
     elapsed     0.185929095   0.31505705 0.00996297883  0.022829833  190.446487
     epsilon     0.020607726   0.02509401 0.00079354225  0.003087969   66.038052
          lp -1279.530195631 147.20004659 4.65487418920 48.438728977    9.234862
    eval_num    41.753000000  51.86665732 1.64016771738  4.503435244  132.644325
      lf_eps     0.020607726   0.02509401 0.00079354225  0.003087969   66.038052
    
    Quantiles:
                   2.5%           25.0%           50.0%           75.0%          97.5%     
       alpha     2.179426379    29.969842513    63.669474110    96.00394084    97.762960108
        beta     1.250627139     1.296154284     1.991453093     2.73946472     3.331785333
      lf_num     0.000000000     0.000000000     0.000000000     0.00000000     0.000000000
           s     5.196843840     5.785744140     8.576647750    13.51223427    17.315852848
     elapsed     0.010573971     0.036188186     0.083558916     0.21068199     0.805442231
     epsilon     0.006842698     0.013109170     0.013109170     0.02130787     0.061662663
          lp -1502.572570399 -1413.891700644 -1276.055902488 -1122.36881489 -1115.535976220
    eval_num     4.000000000    10.000000000    22.000000000    46.00000000   190.000000000
      lf_eps     0.006842698     0.013109170     0.013109170     0.02130787     0.061662663
    
    


Plot the regerssion line and observations


```julia
xi = 30.0:0.1:70.0
yi = mean(chn[:alpha]) .+ mean(chn[:beta])*xi

scatter(x, y, lab="Observations")
plot!(xi, yi, lab="Regression line")

##-
```




![svg](output_12_0.svg)



*This notebook was generated using [Literate.jl](https://github.com/fredrikekre/Literate.jl).*
